function main(alg)

clear global

global faces members classes total numrow numcol vecsize 
global tr_face te_face right_perc num_right right_perc1 right_perc2

% load images
%load_image;
load 'image.mat';
right_perc = zeros(members(1)-1, 1);
right_perc1 = zeros(members(1)-1, 1);
right_perc2 = zeros(members(1)-1, 1);

posvec = zeros(2,1);
posvec(1) = 1;
posvec(2) = 5;

% sampling
for i = 1:members(1)-1
    disp(strcat('i=',num2str(i)));
    for pos = 1:2
        j = posvec(pos);
        disp(strcat('j=',num2str(j)));
	    for k = 1:classes
            cls_s = (k-1)*members(1);
		    trn_s = (k-1)*i;
		    tst_s = (k-1)*(members(1)-i);
	        if j+i-1 > members(1)
                tr_face(:,trn_s+1:trn_s+members(1)-j+1) = faces(:,cls_s+j:cls_s+members(1));
                tr_face(:,trn_s+members(1)-j+2:trn_s+i) = faces(:,cls_s+1:cls_s+j+i-1-members(1));
                te_face(:,tst_s+1:tst_s+members(1)-i) = faces(:,cls_s+j+i-members(1):cls_s+j-1);
            else
                tr_face(:,trn_s+1:trn_s+i) = faces(:,cls_s+j:cls_s+j+i-1);
				if j == 1
				    te_face(:,tst_s+1:tst_s+members(1)-i) = faces(:,cls_s+j+i:cls_s+members(1));
				elseif j+i-1 == members(1)
				    te_face(:,tst_s+1:tst_s+members(1)-i) = faces(:,cls_s+1:cls_s+j-1);
				else
					te_face(:,tst_s+1:tst_s+j-1) = faces(:,cls_s+1:cls_s+j-1);
				    te_face(:,tst_s+j:tst_s+members(1)-i) = faces(:,cls_s+j+i:cls_s+members(1));
				end
		    end
		end

        % run the specified algorithm using tr_face and te_face
        switch (alg)
        case 'EF'     % EigenFace
            stat_ef(i);
		case 'FF'     % FisherFace
            stat_ff(i);
        case 'MF'     % MeanFace
            stat_mf(i);
        case 'QR'     % QR
            stat_qr(i);
        case 'SVD'     % SVD 1&2
            stat_svd(i);
        end

		right_perc(i) = right_perc(i) + num_right/((members(1)-i)*classes);
    end
end


if alg(1) == 'S'
    right_perc1 = right_perc1 / members(1);
    disp(strcat('overall SVD1 %=',num2str(right_perc1)));
    right_perc2 = right_perc2 / members(1);
    disp(strcat('overall SVD2 %=',num2str(right_perc2)));
else
    right_perc = right_perc / members(1);
    disp(strcat('overall %=',num2str(right_perc)));
end
