function stat_ef(tr_num)

global faces members classes total numrow numcol vecsize tr_proj te_proj
global tr_face te_face num_right 

te_num = members(1) - tr_num;
tr_total = tr_num * classes;
te_total = total - tr_total;


% Find the mean of the training set
tr_mean = sum(tr_face, 2) / tr_total;

% subtract the mean from the image matrice
h = waitbar(0, 'Subtracting the mean from all the images ...');
for i = 1:tr_total
    newfaces(:,i) = tr_face(:,i) - tr_mean;
    waitbar(i/tr_total, h);
end
close(h);


% Find Wef
h = waitbar(0.05, 'Finding the Wef ...');
[V,D] = eig(transpose(newfaces) * newfaces);
waitbar(0.1, h);
V = newfaces * V;
waitbar(0.15, h);
[Y, I] = sort(diag(D));
I = flipud(I);
waitbar(0.2, h);
for i = 1:tr_total-1
    Wef(:,i) = V(:,I(i));
    Wef(:,i) = Wef(:,i) / norm(Wef(:,i));
    waitbar(0.2 + i * 0.8 / (tr_total-1), h);
end
close(h);


% Find the accuracy rate
tr_proj = Wef' * tr_face;
te_proj = Wef' * te_face;
find_accuracy(tr_total, te_total, tr_num, te_num);
disp(strcat('num_right=',num2str(num_right)));
disp(strcat('%=',num2str(num_right/((members(1)-tr_num)*classes))));
