function stat_ff(tr_num)

global faces members classes total numrow numcol vecsize 
global tr_face te_face errors num_right
global Wfld I V i Wpca Sb Sw cl_mean tr_mean newfaces D dist Wopt
global tr_proj te_proj tr_total num_major te_total match index 

te_num = members(1) - tr_num;
tr_total = tr_num * classes;
te_total = total - tr_total;


% Find the mean of the training set
for i = 1:classes
    cl_mean(:,i) = sum(tr_face(:,(i-1)*tr_num+1:i*tr_num), 2) / tr_num;
end
tr_mean = sum(tr_face, 2) / tr_total;


% subtract the mean from the image matrice
h = waitbar(0, 'Subtracting the mean from all the images ...');
for i = 1:tr_total
    newfaces(:,i) = tr_face(:,i) - tr_mean;
    waitbar(i/tr_total, h);
end
close(h);


% Find Wpca
h = waitbar(0.05, 'Finding the Wpca ...');
[V,D] = eig(transpose(newfaces) * newfaces);
waitbar(0.1, h);
V = newfaces * V;
waitbar(0.15, h);
[Y, I] = sort(diag(D));
I = flipud(I);
waitbar(0.2, h);
for i = 1:tr_total-classes
    Wpca(:,i) = V(:,I(i));
    Wpca(:,i) = Wpca(:,i) / norm(Wpca(:,i));
    waitbar(0.2 + i * 0.8 / (tr_total-classes), h);
end
close(h);


% Find Sb
h = waitbar(0, 'Finding the between-class scatter matrix ...');
for i = 1:classes
    Sb(:,i) = sqrt(tr_num) * (cl_mean(:,i) - tr_mean);
    waitbar(i/classes, h);
end
Sb2 = transpose(Wpca) * Sb * transpose(Sb) * Wpca;
close(h);


% Find Sw
h = waitbar(0, 'Finding the within-class scatter matrix ...');
j = 1;
k = 1;
for i = 1:tr_total
    Sw(:,i) = tr_face(:,i) - cl_mean(:,j);
    k = k + 1;
    if k > tr_num
	j = j + 1;
	k = 1;
    end
    waitbar(i/tr_total, h);
end
Sw2 = transpose(Wpca) * Sw * transpose(Sw) * Wpca;
close(h);


% Find the Wfld
h = waitbar(0.10, 'Finding the Wfld ...');
[V,D] = eig(inv(Sw2) * Sb2);
waitbar(0.15, h);
[Y, I] = sort(diag(D));
I = flipud(I);
waitbar(0.2, h);
for i = 1:classes-1
    Wfld(:,i) = V(:,I(i));
    waitbar(0.2 + i * 0.8 / (classes-1), h);
end
close(h);


% Form Wopt
Wopt = Wpca * Wfld;


% Find the accuracy rate
tr_proj = Wopt' * tr_face;
te_proj = Wopt' * te_face;
find_accuracy(tr_total, te_total, tr_num, te_num);
disp(strcat('num_right=',num2str(num_right)));
disp(strcat('%=',num2str(num_right/((members(1)-tr_num)*classes))));

