function stat_svd(tr_num)

global faces members classes total numrow numcol vecsize tr_proj te_proj
global tr_face te_face num_right Ws1 Ws2 right_perc1 right_perc2

te_num = members(1) - tr_num;
tr_total = tr_num * classes;
te_total = total - tr_total;


% Find the svd for each class
h=waitbar(0,'Finding the singular vector of each class ...');
count = 1;
for i = 1:classes
    temp = tr_face(:,count:count+tr_num-1);
    count = count + tr_num;
    [U0,S0,V0] = svd(temp, 0);
    svd1(:,i) = U0(:,1);
    if tr_num > 1
        svd2(:,2*i-1:2*i) = U0(:,1:2);
    end
    waitbar(i/classes, h);
end
close(h);


% Find Ws1 and Ws2
[Ws1, R] = qr(svd1, 0);
if tr_num > 1
    [Ws2, R] = qr(svd2, 0);
end


% Find the accuracy rate
tr_proj = Ws1' * tr_face;
te_proj = Ws1' * te_face;
disp('SVD 1:');
find_accuracy(tr_total, te_total, tr_num, te_num);
disp(strcat('num_right=',num2str(num_right)));
disp(strcat('%=',num2str(num_right/te_total)));
right_perc1(tr_num) = right_perc1(tr_num) + num_right/te_total;

if tr_num > 1
    tr_proj = Ws2' * tr_face;
    te_proj = Ws2' * te_face;
    disp('SVD 2:');
    find_accuracy(tr_total, te_total, tr_num, te_num);
    disp(strcat('num_right=',num2str(num_right)));
    disp(strcat('%=',num2str(num_right/te_total)));
    right_perc2(tr_num) = right_perc2(tr_num) + num_right/te_total;
end
